=== src/activities/baby_keyboard/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2020 Timothée Giet <animtim@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/baby_keyboard *.qml *.svg *.js)
