=== src/activities/babymatch/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Pulkit Gupta <pulkitgenius@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/babymatch *.qml *.svg *.js resource/*.svg resource/*/*)
