=== src/activities/ballcatch/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Johnny Jazeix <jazeix@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/ballcatch *.qml *.svg *.js resource/*)
