=== src/activities/bargame/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2017 UTKARSH TIWARI <iamutkarshtiwari@kde.org>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/bargame *.qml *.svg *.js resource/*)
