=== debian/changelog ===
gcompris-qt (4.0-1build3) noble; urgency=high

  * No change rebuild against libqt5core5t64, libqt5gui5t64,
    libqt5network5t64, libqt5widgets5t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:39:24 +0200

gcompris-qt (4.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:36:08 +0000

gcompris-qt (4.0-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:27:53 +0000

gcompris-qt (4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - disable-openssl.diff: refresh/update
  * Disable a test that fails because of the missing voices; patch
    tests-no-voices.diff.

 -- Pino Toscano <pino@debian.org>  Sat, 24 Feb 2024 07:04:46 +0100
