=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
export QT_SELECT := qt5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DKDE_INSTALL_BINDIR=/usr/games -DQML_BOX2D_MODULE=disabled -DBUILD_TESTING=ON -DCOMPILE_DOC=ON

override_dh_auto_test:
	xvfb-run -a dh_auto_test

execute_after_override_dh_auto_clean:
	find src -name '*.qrc' -delete
	rm -f src/activities/activities_out.txt
