=== debian/changelog ===
gcompris-qt (4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Thu, 23 May 2024 11:37:33 +0200
