## gcompris-qt 4.2

=== debian/changelog ===
gcompris-qt (4.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Fri, 20 Sep 2024 06:18:32 +0200
