## gcompris-qt 4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_QML_DEBUG")
 
 set(GCOMPRIS_MAJOR_VERSION 4)
-set(GCOMPRIS_MINOR_VERSION 0)
+set(GCOMPRIS_MINOR_VERSION 3)
 set(GCOMPRIS_PATCH_VERSION 0)
 
 if("${CMAKE_ANDROID_ARCH}" STREQUAL "arm64")
@@ -178,6 +178,8 @@
 if(CMAKE_HOST_APPLE)
   set(_bundle_bin gcompris-qt.app/Contents/MacOS)
   set(_data_dest_dir bin/${_bundle_bin}/../Resources)
+elseif(HAIKU)
+  set(_data_dest_dir data/Qt5/${GCOMPRIS_EXECUTABLE_NAME})
 else()
   set(_data_dest_dir share/${GCOMPRIS_EXECUTABLE_NAME})
 endif()
@@ -318,6 +320,3 @@
 elseif(ANDROID)
   install(DIRECTORY ${GCOMPRIS_TRANSLATIONS_DIR} DESTINATION "share")
 else()
-  install(DIRECTORY ${GCOMPRIS_TRANSLATIONS_DIR} DESTINATION ${_data_dest_dir})
-endif()
-
