=== src/activities/adjacent_numbers/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2023 Alexandre Laurent <littlewhite.dev@gmail.com>
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/adjacent_numbers *.qml *.svg *.js resource/*/* resource/*.*)
