=== src/activities/enumerate/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Thib ROMAIN <thibrom@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/enumerate *.qml *.svg *.js resource/*.* resource/*/*)
