=== src/activities/grammar_analysis/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2023 Bruno ANSELME <be.root@free.fr>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/grammar_analysis *.qml *.svg *.js resource/*.* resource/*/*.*)
