=== src/activities/learn_quantities/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2021 Timothée Giet <animtim@gmail.com>
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/learn_quantities *.qml *.svg *.js resource/*/*.*)
