=== src/activities/paintings/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Pulkit Gupta <pulkitgenius@gmail.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/paintings *.qml *.svg *.js resource/*/*)
