=== src/activities/target/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2015 Bruno Coudoin <bruno.coudoin@gcompris.net>
#
# SPDX-License-Identifier: BSD-2-Clause
#=============================================================================
GCOMPRIS_ADD_RCC(activities/target *.qml *.svg *.js resource/*.* resource/*/*.*)
