=== debian/changelog ===
gcompris-qt (4.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sat, 07 Dec 2024 21:57:05 +0100
