=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gcompris-qt
 Section: education
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt Extras Team <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt Extras Team <debian-qt-kde@lists.debian.org>
 Uploaders: Simon Quigley <tsimonq2@debian.org>
 Build-Depends: cmake (>= 3.7~),
                debhelper-compat (= 13),
@@ -22,7 +21,7 @@
                qttools5-dev-tools (>= 5.12.0~),
                xauth <!nocheck>,
                xvfb <!nocheck>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gcompris.net/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gcompris-qt
